#include <signal.h>
#include "sendrtp.c"

/* This is a small RTP test program that will dump RTP packets to
 * stdout. */

/* #define DEBUG */

void playrtp(int socket) {
  char buf[1600];
  struct rtpheader *rh=(struct rtpheader*)buf;
  unsigned int *temp=(unsigned int *)buf;
  int len;
  int sequence=0;
  unsigned int psequence;
  unsigned long int ptimestamp;
  for (;;) {
    len=recv(socket,buf,1590,0);
    if (len==0)
      break;
    if (len<0) {
      fprintf(stderr,"socket read error\n");
      exit(1);
    }
    psequence=(((unsigned int)(buf[2]))<<8)+(unsigned char)buf[3];
    psequence &= 0xffff;
    temp[0]=ntohl(temp[0]);
    ptimestamp=ntohl(temp[1]);
    temp[1]=ntohl(temp[1]);	/* timestamp */
/*    temp[2]=ntohl(temp[2]); SSRC */
    temp[3]=ntohl(temp[3]);
#ifndef DEBUG
    if (psequence != sequence+1) {
      if (sequence==0)
	fprintf(stderr,"got first frame, sequence #%d\n",psequence);
      else
	fprintf(stderr,"got wrong frame.  expected %d, got %d\n",sequence+1,psequence);
      sequence=psequence;
    } else
      sequence++;
    fprintf(stderr,"sequence %d\n",sequence);
    if (write(1,buf+sizeof(struct rtpheader),len-sizeof(struct rtpheader))!=(len-sizeof(struct rtpheader)))
      exit(0);
#else
    fprintf(stderr,"len %d: sequence %x timestamp %u fubar %d\n",len,psequence,temp[1],temp[3]);
    {
      char *tmp=(char *)buf;
      tmp+=4*4;
      if (*tmp==(char)0xff && (tmp[1]&0xf0)==(char)0xf0) {
	fprintf(stderr,"MPEG!\n");
      } else {
	fprintf(stderr," %x %x\n",tmp[0] & 0xff,tmp[1] & 0xff);
      }
    }
    write(1,buf,len);
#endif
  }
}

void castrtp(int socket) {
  char buf[1600];
  struct rtpheader *rh=(struct rtpheader*)buf;
  int *temp=(int *)buf;
  int len;
  int sequence=0;
  int first=1;
  for (;;) {
    len=recv(socket,buf,1590,0);
    if (len==0)
      break;
    if (len<0) {
      fprintf(stderr,"socket read error\n");
      exit(1);
    }
    temp[0]=ntohl(temp[0]);
    temp[1]=ntohl(temp[1]);
    temp[2]=ntohl(temp[2]);
    if (rh->b.sequence != sequence+1)
      sequence=rh->b.sequence;
    else
      sequence++;
#if 0
    if (first) {
      char *tmp=buf+sizeof(struct rtpheader);
      if (tmp[0]!=(char)0xff || (tmp[1]&0xf0)!=0xf0)
	continue;
      first=0;
    }
#endif
    if (write(1,buf+sizeof(struct rtpheader),len-sizeof(struct rtpheader))!=(len-sizeof(struct rtpheader)))
      exit(0);
  }
}

main(int argc, char *argv[]) {
  struct rtpheader rh;
  struct sockaddr_in si;
  int socket;
  char *ip;
  int port;

  signal(SIGPIPE,SIG_IGN);
  if (strstr(argv[0],"unicast.cgi")) {
    ip="224.17.23.42"; port=5004;
    write(1,"HTTP/1.0 200 OK\nContent-Type: audio/mpeg\n\n",42);
    socket=makeclientsocket(ip,port,1,&si);
    castrtp(socket);
    exit(0);
  }

  if (argc<3) {
    fprintf(stdout,"Using defaults: 224.0.1.2:5004\n");
    ip="224.0.1.2"; port=5004;
  } else {
    ip=argv[1];
    port=atoi(argv[2]);
  }

#ifdef SEND
  socket=makesocket(ip,port,1,&si);
  initrtp(&rh);
  sendrtp(socket,&si,&rh,"foo",3);
#else
  socket=makeclientsocket(ip,port,1,&si);
  playrtp(socket);
#endif
  close(socket);
}
