#include <stdlib.h>
#include <string.h>
#include <netinet/in.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>

/* This has to be the cheapest RTP stack ever written, if it can even be
 * called RTP stack.  Does not even begin to try to implement RTCP.
 * Only small wrapper routines to open a sending or receiving socket. */

/* Actually, this is just a hack to test my lame patch to send out rtp. */

struct rtpbits {
  int v:2;	/* version: 2 */
  int p:1;	/* is there padding appended: 0 */
  int x:1;	/* number of extension headers: 0 */
  int cc:4;	/* number of CSRC identifiers: 0 */
  int m:1;	/* marker: 0 */
  int pt:7;	/* payload type: 14 for MPEG audio */
  unsigned int sequence:16;	/* sequence number: random */
};

struct rtpheader {	/* in network byte order */
  struct rtpbits b;
  int timestamp;	/* start: random */
  int ssrc;		/* random */
  int audioheader;	/* ?! =0 */
};

void initrtp(struct rtpheader *foo) { /* fill in the MPEG audio defaults */
  /* Note: MPEG audio defines a timestamping base frequency of 90000 Hz. */
  foo->b.v=2;
  foo->b.p=0;
  foo->b.x=0;
  foo->b.cc=0;
  foo->b.m=0;
  foo->b.pt=14;		/* MPEG Audio */
  foo->b.sequence=rand() & 65535;
  foo->timestamp=rand();
  foo->ssrc=rand();
  foo->audioheader=0;
}

/* Send a single RTP packet, converting the RTP header to network byte
 * order. */
int sendrtp(int fd, struct sockaddr_in *sSockAddr, struct rtpheader *foo, void *data, int len) {
  char *buf=alloca(len+sizeof(struct rtpheader));
  int *cast=(int *)foo;
  int *outcast=(int *)buf;
  outcast[0]=htonl(cast[0]);
  outcast[1]=htonl(cast[1]);
  outcast[2]=htonl(cast[2]);
  memmove(outcast+4,data,len);
  return sendto(fd,buf,len+sizeof(*foo),0,(struct sockaddr *)sSockAddr,sizeof(*sSockAddr));
}

/* create a sender socket. */
int makesocket(char *szAddr,unsigned short port,int TTL,struct sockaddr_in *sSockAddr) {
  int          iRet, iLoop = 1;
  struct       sockaddr_in sin;
  char         cTtl = (char)TTL;
  char         cLoop=0;

  int iSocket = socket( AF_INET, SOCK_DGRAM, 0 );
  if (iSocket < 0) {
    fprintf(stderr,"socket() failed.\n");
    exit(1);
  }

  sSockAddr->sin_family = sin.sin_family = AF_INET;
  sSockAddr->sin_port = sin.sin_port = htons(port);
  sSockAddr->sin_addr.s_addr = inet_addr(szAddr);

  iRet = setsockopt(iSocket, SOL_SOCKET, SO_REUSEADDR, &iLoop, sizeof(int));
  if (iRet < 0) {
    fprintf(stderr,"setsockopt SO_REUSEADDR failed\n");
    exit(1);
  }

  iRet = setsockopt(iSocket, IPPROTO_IP, IP_MULTICAST_TTL, &cTtl, sizeof(char));
  if (iRet < 0) {
    fprintf(stderr,"setsockopt IP_MULTICAST_TTL failed.  multicast in kernel?\n");
    exit(1);
  }

  cLoop = 1;	/* !? */
  iRet = setsockopt(iSocket, IPPROTO_IP, IP_MULTICAST_LOOP,
                    &cLoop, sizeof(char));
  if (iRet < 0) {
    fprintf(stderr,"setsockopt IP_MULTICAST_LOOP failed.  multicast in kernel?\n");
    exit(1);
  }

  return iSocket;
}

/* create a receiver socket, i.e. join the multicast group. */
int makeclientsocket(char *szAddr,unsigned short port,int TTL,struct sockaddr_in *sSockAddr) {
  int socket=makesocket(szAddr,port,TTL,sSockAddr);
  struct ip_mreq blub;
  struct sockaddr_in sin;
  sin.sin_family=AF_INET;
  sin.sin_port=htons(port);
  sin.sin_addr.s_addr=0;
  if (bind(socket,&sin,sizeof(sin))) {
    perror("bind failed");
    exit(1);
  }
  blub.imr_multiaddr.s_addr = inet_addr(szAddr);
  blub.imr_interface.s_addr = 0;
  if (setsockopt(socket,IPPROTO_IP,IP_ADD_MEMBERSHIP,&blub,sizeof(blub))) {
    perror("setsockopt IP_ADD_MEMBERSHIP failed (multicast kernel?)");
    exit(1);
  }
  return socket;
}

